<!--* 下拉树形选择 组件-->
<template>
  <el-select ref="select" style="min-width: 260px" :value="value" v-model="valueName" collapse-tags :multiple="multiple" :clearable="clearable">
    <!-- @clear="clearHandle" -->
    <el-option :value="valueName" class="options">
      <el-tree
        show-checkbox
        :default-expanded-keys="openTree"
        id="tree-option"
        ref="selectTree"
        :accordion="accordion"
        :data="datas"
        :props="props"
        :default-checked-keys='valueArr'
        :node-key="props.value"
        @check="handleCheckChange"
      >
        <span slot-scope="{ data }"> <i :class="[data.color != null ? 'ification_col' : '']" :style="{ 'background-color': data.color }"></i>&nbsp;&nbsp;{{ data.name }} </span>
      </el-tree>
    </el-option>
  </el-select>
</template>
<script>
  import {
    listCommonuser
  } from "@/api/common.js"
export default {
  name: 'el-tree-select',
  props: {
    datas:{
      type: Array,
      default: () => {
        return []
      }
    },
    // 配置项
    props: {
      type: Object,
      default: () => {
        return {
          value: 'id',
          children: 'children',
          label: 'name'
        }
      }
    },
    // 初始值（单选）
    value: {
      type: Object,
      default: () => {
        return {}
      }
    },
    // 初始值（多选）
    valueMultiple: {
      type: Array,
      default: () => {
        return []
      }
    },
    valueArr: {
      type: Array,
      default: () => {
        return []
      }
    },
    // 可清空选项
    clearable: {
      type: Boolean,
      default: false
    },
    // 自动收起
    accordion: {
      type: Boolean,
      default: false
    },
    // 是否支持多选
    multiple: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      // options: [],
      resultValue: [], // 传给父组件的数组对象值
      valueName: [], // 输入框显示值
      openTree: [] // 需要展开的id
    }
  },
  watch: {
    value () {
      this.resultValue = this.valueMultiple // 初始值
      this.initHandle()
    }
  },
  mounted () {
    this.resultValue = this.valueMultiple
    this.initHandle()
    // this.getSelectTreeList()
     // 初始值
    
  },
  methods: {
    // 获取 部门 tree
    // getSelectTreeList: function () {
    //   listCommonuser({
    //     page_size: 999,
    //   }).
    //   then((res) => {
    //     // this.userdata = res.data ? res.data.reverse() : [];
    //     this.datas = res.data ? res.data.reverse() : [];

    //     // this.userdatabefore = res.data ? res.data : [];
    //     // let contactData = this.contactUser(data)
    //     // this.userdata = this.sortDepartment(contactData,'department_id')
    //     // console.log("this.userdata",this.userdata)
    //   }).catch(error => {
    //     console.log(error)
    //   })
    // },
    // 初始化显示
    initHandle () {
      if (this.resultValue) {
        this.resultValue.forEach((item) => this.valueName.push(item.name))
      }
      this.initScroll()
    },
    // 初始化滚动条
    initScroll () {
      this.$nextTick(() => {
        let scrollWrap = document.querySelectorAll('.el-scrollbar .el-select-dropdown__wrap')[0]
        let scrollBar = document.querySelectorAll('.el-scrollbar .el-scrollbar__bar')
        scrollWrap.style.cssText = 'margin: 0px; max-height: none; overflow: hidden;'
        scrollBar.forEach((ele) => (ele.style.width = 0))
      })
    },
    // 从输入框中直接删除某个值时
    changeValue (val) {
      // 多选（同时删掉传给父组件中多余的值，再传给父组件）
      // this.resultValue.map((item, index) => {
      //   let i = val.indexOf(item.name)
      //   if (i === -1) {
      //     this.resultValue.splice(index, 1)
      //   }
      // })
      this.resultValue = []
      this.valueMultiple = []
      this.valueArr = []
      this.$emit('getValue', this.resultValue)
    },
    // 勾选 /反选
    handleCheckChange (checkData,data ) {
      this.valueName = []
      this.resultValue = []
      if(data.checkedNodes.length>0){
        data.checkedNodes.map(item=>{
          if(!item.children){
            this.resultValue.push(item)
          }
        })
      }else{
        this.resultValue = []
      }
      this.resultValue.forEach((item) => {
        this.valueName.push(item.name) // 输入框显示值
      })
      this.$emit('getValue', this.resultValue)
    },
    // 默认展开全部
    openTreeList (list) {
      list.forEach((item) => {
        this.openTree.push(item.id)
        if (item.children && item.children.length) {
          this.openTreeList(item.children)
        }
      })
    },

    // 清除选中
    clearHandle () {
      this.valueName = []
      this.resultValue = []
      // this.valueMultiple = []
      // this.valueArr = []
      this.clearSelected()
      this.$emit('getValue', this.resultValue)
    },
    // 清空选中样式
    clearSelected () {
      let allNode = document.querySelectorAll('#tree-option .el-tree-node')
      allNode.forEach((element) => element.classList.remove('is-current'))
    }
  }
}
</script>
<style lang="scss" scoped>
.el-scrollbar .el-scrollbar__view .el-select-dropdown__item {
  height: auto;
  max-height: 300px;
  padding: 0;
  overflow: hidden;
  overflow-y: auto;
}

.el-select-dropdown__item.selected {
  font-weight: normal;
}

ul li >>> .el-tree .el-tree-node__content {
  height: auto;
  padding: 0 20px;
}

.el-tree-node__label {
  font-weight: normal;
}

.el-tree >>> .is-current .el-tree-node__label {
  color: #409eff;
  font-weight: 700;
}

.el-tree >>> .is-current .el-tree-node__children .el-tree-node__label {
  color: #606266;
  font-weight: normal;
}

.el-popper {
  z-index: 9999;
}

.ification_col {
  width: 20px;
  height: 10px;
  display: inline-block;
}

.el-select-dropdown__item::-webkit-scrollbar {
  display: none !important;
}

.el-select {
  ::v-deep.el-tag__close {
    display: none !important; //隐藏在下拉框多选时单个删除的按钮
  }
}
</style>

